#!/bin/sh
# Install the MapWOC workaround for incompatible intel kernel module

arch_intel=$(grep -c -e "vendor_id.*intel" -i /proc/cpuinfo)

KVERS=$(uname -r)

if [ $arch_intel -gt 0 ] ; then
    echo "Installing mapwoc KVM Kernel Modules for Intel Processors."
    cp "/usr/lib/mapwoc/modules/kvm-intel.ko" \
       "/lib/modules/$KVERS/kernel/arch/x86/kvm/kvm-intel.ko"
    cp "/usr/lib/mapwoc/modules/kvm.ko" \
       "/lib/modules/$KVERS/kernel/arch/x86/kvm/kvm.ko"
elif [ -e /lib/modules/$KVERS/kernel/arch/x86/kvm/kvm-amd.ko.orig -o
       -L /lib/modules/$KVERS/kernel/arch/x86/kvm/kvm.ko.orig ] && \
     [ \! -e /lib/modules/$KVERS/kernel/arch/x86/kvm/kvm-amd.ko ] &&
     [ \! -e /lib/modules/$KVERS/kernel/arch/x86/kvm/kvm.ko ] ; then
    ln -s "/lib/modules/$KVERS/kernel/arch/x86/kvm/kvm-amd.ko.orig" \
          "/lib/modules/$KVERS/kernel/arch/x86/kvm/kvm-amd.ko"
    ln -s "/lib/modules/$KVERS/kernel/arch/x86/kvm/kvm.ko.orig" \
          "/lib/modules/$KVERS/kernel/arch/x86/kvm/kvm.ko"
fi
